var icms = icms || {};

icms.pageautoload = (function ($) {
    
    this.options = {
        
        MAIN_CONTAINER : "article", // идентификатор контейнера куда выводятся данные
                                    // по нему, при прокрутке страницы, определяется когда подгружать новые данные
        BOTTOM_MARGIN : 150,  // отступ в пикселях от низа страницы при котором срабатывает событие подгрузки данных
        
        NEXT_BTN_CAPTION : "Следующая",  // заголовок ссылки указывающей на следующую страницу
        
        LOADING_CAPTION : "Загрузка...",  // надпись информирующая о загрузке данных 
        
        SCROLL_SPEED : 1100,  // скорость прокрутки страницы при клике на ссылку-якорь
        
        PAGE_ADD_SPEED : 600,  // скорость анимации добавления ajax данных
        
        PAGEBAR_CSS : {  // стили pagebar'а
            "position" : "fixed",
            "z-index" : "999999",
            "padding" : "15px",
            "margin" : "0",
            "background-color" : "rgba(255, 255, 255, 0.9)",
            "border" : "1px solid #DDDDDD"
        },
        
        CONTAINERS : [   // список идентификаторов блоков куда выводятся подгружаемые ajax данные
            ".content_list",         // вывод контента            
            ".activity-list",        // лента активности
            "#comments_list",        // комментарии
            ".groups-list",          // список групп
            "#album-photos-list",    // фотоальбомы
            "#search_results_list",  // список результатов поиска
            "#users_profiles_list",  // список пользователей
            "#users_karma_log_list", // лог по карме
            "#entries_list"          // стена 
        ]
        
    } 

    var is_ajax_process = false;  // флаг выполнения ajax
    var pb_css_top;  // установка отступа pagebar сверху
    var pb_css_right;  // отступ справа
    var con_obj_name;  // класс контейнера, заданный в массиве

    //====================================================================//    
    
    this.onDocumentReady = function(){
        
        if (!History.enabled) {
            return;
        }
        
        // получаем название класса контейнера для текущей страницы
        icms.pageautoload.options.CONTAINERS.forEach( function(item){
            if ($(item).length > 0) {
                    con_obj_name = item;
                };
            });        
        
        var pbObj = $(".pagebar");
        if (! pbObj.length > 0) { return false; }
        
        $(".pagebar_notice", pbObj).remove();
        
        var container = $(icms.pageautoload.options.MAIN_CONTAINER);
        container.append("<div class='loading' style='display: none; margin-top: 10px;'>" + icms.pageautoload.options.LOADING_CAPTION + "</div>");
        container.append("<div id='pagebar_data' style='display: none;'/>");
        
        var page_current = parseInt( $(".pagebar .pagebar_current").text(), 10 );
        
        var pbData = $("#pagebar_data");       
        var pBar = []; // = pbData.data("pageBar");
        pBar[page_current-1] = pbObj[0].outerHTML;
        
        pbData.data("pageArray", [page_current])
              .data("pageBar", pBar);                 
        
        $(con_obj_name).prepend("<div id='page_anchor_" + page_current + "' style='display: none;'>" + page_current + "</div>");
        
        var screenHeight = $(window).height();

        var h_hght = container.offset().top + 42; // отступ сверху (высота шапки и меню) + отступ для хлебных крошек, чтобы не перекрывало
        var h_mrg = 10; // отступ когда шапка уже не видна
        
        pb_css_top = h_hght;

        $(window).scroll(function(){
            
            var scrollNow = $(this).scrollTop();

            ( scrollNow + h_mrg < h_hght ) ? pb_css_top = h_hght - scrollNow
                                           : pb_css_top = h_mrg;
            
            var elTops = [];
            $("div[id ^= 'page_anchor_']").each(function(item){
                elTops.push($(this).next().offset().top);
            });
            
            var containerHeight = container.height();
            var sumHeight = 0;
            
            var page = pbData.data("pageArray")[0]; // 1;
            for (var i=0; i<elTops.length; i++) {
                
                if (i != 0 && scrollNow >= elTops[i]-screenHeight/2) {page++;}
                
            }

            sumHeight = screenHeight + scrollNow;
            var activeHeight = containerHeight - sumHeight;

            if (activeHeight < icms.pageautoload.options.BOTTOM_MARGIN ){
                
                page = pbData.data("pageArray")[0] + elTops.length-1;
                
                if (!is_ajax_process) {
                    is_ajax_process = true;
                    var url = $(".pagebar .pagebar_current").next().attr("href");

                    icms.pageautoload.getPage(url);
                }
          
            }
            
            if (!is_ajax_process) {
                var url = $(".pagebar a:contains(" + page + ")").attr("href");
                History.pushState({}, null, url);

                icms.pageautoload.getPagebar(page);
            }

        });
        
        $(window).resize(function(){ // высчитываем отступ справа при ресайзе окна
            pb_css_right = $(document).width() - container.outerWidth() - container.offset().left + 10;
            icms.pageautoload.setCSS();
        });
        
        $(window).resize(); // вызываем resize, чтобы установить значение pb_css_right при загрузке страницы

    }
    
    //====================================================================//

    this.getPage = function(url){
        // если ссылка не передана ...
        if (url == undefined) {
            is_ajax_process = false;
            return false;
        }
        // если это "кнопка" "Следующая" ...
        var nextObj = $(".pagebar .pagebar_current").next().text();
        if ( nextObj === $(".pagebar #a_next_btn").text() ) {
            is_ajax_process = false;
            return false;
        }
            
        var page_next = parseInt( nextObj , 10 );
        var pbData = $("#pagebar_data");
        
        // если страница была ранее загружена
        if ($.inArray(page_next, pbData.data("pageArray")) !== -1) {
            is_ajax_process = false;
            return false;
        }
        var loadObj = icms.pageautoload.options.MAIN_CONTAINER + " .loading";
        $(loadObj).show();

        $.ajax({
            url      : url,               // указываем URL и
            type     : "POST",
            dataType : "html",            // тип загружаемых данных
            success  : function(data){    // вешаем свой обработчик на функцию success

                // обрабатываем полученные данные (page_next становится текущей страницей)

                $(con_obj_name).append("<div id='page_anchor_" + page_next + "' style='display: none;'>" + page_next + "</div>");

                var pArr = pbData.data("pageArray");
                pArr.push(page_next); // добавляем номер загруженной страницы 
                pbData.data("pageArray", pArr);

                var dataObj;
                
                $(data).is(con_obj_name) ? dataObj = $(data)
                                         : dataObj = $(data).find(con_obj_name).parent().children();

                dataObj.filter(con_obj_name).children()
                       .appendTo($(con_obj_name)).hide().fadeIn(icms.pageautoload.options.PAGE_ADD_SPEED); //добавляем полученные данные к текущему списку

                //... тут нужно обработать на повторный вывод заголовков <h3>
                 
                $(loadObj).show();

                dataObj.filter(".pagebar") //заменяем панель pagebar
                       .replaceAll($(".pagebar"));

                $(".pagebar > .pagebar_notice").remove();

                var pBar = pbData.data("pageBar");
                pBar[page_next-1] = $(".pagebar")[0].outerHTML;
                //pBar.push( $(".pagebar")[0].outerHTML );
                pbData.data("pageBar", pBar);
                             
                icms.pageautoload.getPagebar(page_next-1);
                 
                $(loadObj).hide();

                is_ajax_process = false;

               }
        });
        
    }
      
    //====================================================================//
    
    // устанавливает ссылки-якоря на уже загруженных страницах
    this.setPagebarLinks = function() {
        
        $(".pagebar a").each(function(o){
            
            // определяем номер страницы
            var a_href = $(this).attr("href");
            var page_num  = a_href.indexOf("?page=");

            if ( page_num !== -1 ) {                
                page_num = parseInt( a_href.substr( page_num + 6 ), 10); // стр. 2, 3, 4, ...                
            } else {                 
                page_num = 1; // стр. 1 и стр. "Предыдущая" если активная страница №2                  
            }
            
            // если страница была ранее загружена устанавливаем якорь
            if ( $.inArray(page_num, $("#pagebar_data").data("pageArray")) !== -1 ) {
                
                $(this).attr("name", "#page_anchor_" + page_num);
                $(this).addClass("onPageNow");
                
                // если текст ссылки не число, тогда это "Предыдущая"
                if ( isNaN(parseInt( $(this).text(), 10 )) ) {                
                    $(this).attr("id", "a_back_btn");                
                }
                
            }
                       
            // устанавливаем id для ссылки "Следующая"
            if ( $(this).text().toUpperCase() === icms.pageautoload.options.NEXT_BTN_CAPTION.toUpperCase() ) {
                $(this).attr("id", "a_next_btn");                
            }
            
        });    
        
    }
    
    //====================================================================//
    this.getPagebar = function(page) {
        
        var pBar = $("#pagebar_data").data("pageBar");
        $(".pagebar").replaceWith(pBar[page-1]); //заменяем панель pagebar
    
        icms.pageautoload.setPagebarLinks();
        icms.pageautoload.setAllClick();
        icms.pageautoload.setCSS();
       
    }    
    
    //====================================================================//
    
    // вешаем обработчик клика по ссылкам
    this.setAllClick = function() {   
        
        icms.pageautoload.setClick( $(".pagebar a.onPageNow") );  
        
    }
    
    this.setClick = function(object) {
           
        object.click(function() {
            var thisName = this.name;
            var targetOffset = $(thisName).next().offset().top;
            $("html,body").stop().animate({
                    scrollTop: targetOffset
                    }, icms.pageautoload.options.SCROLL_SPEED ).animate({
                            scrollTop: targetOffset -20
                            }, icms.pageautoload.options.SCROLL_SPEED );
            
            return false;
        
        });
        
    }
    
    //====================================================================//
    
    // устанавливает стили для pagebar'а
    this.setCSS = function() {
        
        var pBarObj = $(".pagebar");
        
        pBarObj.css(icms.pageautoload.options.PAGEBAR_CSS);
        pBarObj.css("top", pb_css_top);
        pBarObj.css("right", pb_css_right);

    }
    
    //====================================================================//

    return this; 
    
}).call(icms.pageautoload || {},jQuery);